# Interface ConcurrentNavigableMap<K,V>

Type Parameters:
  `K` - the type of keys maintained by this map
  `V` - the type of mapped values

All Superinterfaces:
  `ConcurrentMap<K,V>, Map<K,V>, NavigableMap<K,V>, SequencedMap<K,V>, SortedMap<K,V>`

All Known Implementing Classes:
  `ConcurrentSkipListMap`

public interface ConcurrentNavigableMap<K,V> extends ConcurrentMap<K,V>, NavigableMap<K,V>
A `ConcurrentMap` supporting `NavigableMap` operations, and recursively so for its navigable sub-maps.

This interface is a member of the Java Collections Framework.

Since:
  1.6

## Nested Class Summary

### Nested classes/interfaces declared in interface Map

`Map.Entry<K,V>`
Modifier and Type
Interface
Description
`static interface`
`Map.Entry<K,V>`
A map entry (key-value pair).

## Method Summary

Modifier and Type
Method
Description
`NavigableSet<K>`
`descendingKeySet()`
Returns a reverse order `NavigableSet` view of the keys contained in this map.
`ConcurrentNavigableMap<K,V>`
`descendingMap()`
Returns a reverse order view of the mappings contained in this map.
`ConcurrentNavigableMap<K,V>`
`headMap(K toKey)`
Returns a view of the portion of this map whose keys are strictly less than `toKey`.
`ConcurrentNavigableMap<K,V>`
`headMap(K toKey, boolean inclusive)`
Returns a view of the portion of this map whose keys are less than (or equal to, if `inclusive` is true) `toKey`.
`NavigableSet<K>`
`keySet()`
Returns a `NavigableSet` view of the keys contained in this map.
`NavigableSet<K>`
`navigableKeySet()`
Returns a `NavigableSet` view of the keys contained in this map.
`ConcurrentNavigableMap<K,V>`
`subMap(K fromKey, boolean fromInclusive, K toKey, boolean toInclusive)`
Returns a view of the portion of this map whose keys range from `fromKey` to `toKey`.
`ConcurrentNavigableMap<K,V>`
`subMap(K fromKey, K toKey)`
Returns a view of the portion of this map whose keys range from `fromKey`, inclusive, to `toKey`, exclusive.
`ConcurrentNavigableMap<K,V>`
`tailMap(K fromKey)`
Returns a view of the portion of this map whose keys are greater than or equal to `fromKey`.
`ConcurrentNavigableMap<K,V>`
`tailMap(K fromKey, boolean inclusive)`
Returns a view of the portion of this map whose keys are greater than (or equal to, if `inclusive` is true) `fromKey`.

### Methods declared in interface ConcurrentMap

`compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`
Modifier and Type
Method
Description
`default V`
`compute(K key, BiFunction<? super K, ? super V, ? extends V> remappingFunction)`
Attempts to compute a mapping for the specified key and its current mapped value, or `null` if there is no current mapping (optional operation).
`default V`
`computeIfAbsent(K key, Function<? super K, ? extends V> mappingFunction)`
If the specified key is not already associated with a value (or is mapped to `null`), attempts to compute its value using the given mapping function and enters it into this map unless `null` (optional operation).
`default V`
`computeIfPresent(K key, BiFunction<? super K, ? super V, ? extends V> remappingFunction)`
If the value for the specified key is present and non-null, attempts to compute a new mapping given the key and its current mapped value (optional operation).
`default void`
`forEach(BiConsumer<? super K, ? super V> action)`
Performs the given action for each entry in this map until all entries have been processed or the action throws an exception.
`default V`
`getOrDefault(Object key, V defaultValue)`
Returns the value to which the specified key is mapped, or `defaultValue` if this map contains no mapping for the key.
`default V`
`merge(K key, V value, BiFunction<? super V, ? super V, ? extends V> remappingFunction)`
If the specified key is not already associated with a value or is associated with null, associates it with the given non-null value (optional operation).
`V`
`putIfAbsent(K key, V value)`
If the specified key is not already associated with a value, associates it with the given value.
`boolean`
`remove(Object key, Object value)`
Removes the entry for a key only if currently mapped to a given value.
`V`
`replace(K key, V value)`
Replaces the entry for a key only if currently mapped to some value.
`boolean`
`replace(K key, V oldValue, V newValue)`
Replaces the entry for a key only if currently mapped to a given value.
`default void`
`replaceAll(BiFunction<? super K, ? super V, ? extends V> function)`
Replaces each entry's value with the result of invoking the given function on that entry until all entries have been processed or the function throws an exception (optional operation).

### Methods declared in interface Map

`clear, containsKey, containsValue, equals, get, hashCode, isEmpty, put, putAll, remove, size`
Modifier and Type
Method
Description
`void`
`clear()`
Removes all of the mappings from this map (optional operation).
`boolean`
`containsKey(Object key)`
Returns `true` if this map contains a mapping for the specified key.
`boolean`
`containsValue(Object value)`
Returns `true` if this map maps one or more keys to the specified value.
`boolean`
`equals(Object o)`
Compares the specified object with this map for equality.
`V`
`get(Object key)`
Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.
`int`
`hashCode()`
Returns the hash code value for this map.
`boolean`
`isEmpty()`
Returns `true` if this map contains no key-value mappings.
`V`
`put(K key, V value)`
Associates the specified value with the specified key in this map (optional operation).
`void`
`putAll(Map<? extends K, ? extends V> m)`
Copies all of the mappings from the specified map to this map (optional operation).
`V`
`remove(Object key)`
Removes the mapping for a key from this map if it is present (optional operation).
`int`
`size()`
Returns the number of key-value mappings in this map.

### Methods declared in interface NavigableMap

`ceilingEntry, ceilingKey, firstEntry, floorEntry, floorKey, higherEntry, higherKey, lastEntry, lowerEntry, lowerKey, pollFirstEntry, pollLastEntry, reversed`
Modifier and Type
Method
Description
`Map.Entry<K,V>`
`ceilingEntry(K key)`
Returns a key-value mapping associated with the least key greater than or equal to the given key, or `null` if there is no such key.
`K`
`ceilingKey(K key)`
Returns the least key greater than or equal to the given key, or `null` if there is no such key.
`Map.Entry<K,V>`
`firstEntry()`
Returns a key-value mapping associated with the least key in this map, or `null` if the map is empty.
`Map.Entry<K,V>`
`floorEntry(K key)`
Returns a key-value mapping associated with the greatest key less than or equal to the given key, or `null` if there is no such key.
`K`
`floorKey(K key)`
Returns the greatest key less than or equal to the given key, or `null` if there is no such key.
`Map.Entry<K,V>`
`higherEntry(K key)`
Returns a key-value mapping associated with the least key strictly greater than the given key, or `null` if there is no such key.
`K`
`higherKey(K key)`
Returns the least key strictly greater than the given key, or `null` if there is no such key.
`Map.Entry<K,V>`
`lastEntry()`
Returns a key-value mapping associated with the greatest key in this map, or `null` if the map is empty.
`Map.Entry<K,V>`
`lowerEntry(K key)`
Returns a key-value mapping associated with the greatest key strictly less than the given key, or `null` if there is no such key.
`K`
`lowerKey(K key)`
Returns the greatest key strictly less than the given key, or `null` if there is no such key.
`Map.Entry<K,V>`
`pollFirstEntry()`
Removes and returns a key-value mapping associated with the least key in this map, or `null` if the map is empty (optional operation).
`Map.Entry<K,V>`
`pollLastEntry()`
Removes and returns a key-value mapping associated with the greatest key in this map, or `null` if the map is empty (optional operation).
`default NavigableMap<K,V>`
`reversed()`
Returns a reverse-ordered view of this map.

### Methods declared in interface SequencedMap

`sequencedEntrySet, sequencedKeySet, sequencedValues`
Modifier and Type
Method
Description
`default SequencedSet<Map.Entry<K,V>>`
`sequencedEntrySet()`
Returns a `SequencedSet` view of this map's `entrySet`.
`default SequencedSet<K>`
`sequencedKeySet()`
Returns a `SequencedSet` view of this map's `keySet`.
`default SequencedCollection<V>`
`sequencedValues()`
Returns a `SequencedCollection` view of this map's `values` collection.

### Methods declared in interface SortedMap

`comparator, entrySet, firstKey, lastKey, putFirst, putLast, values`
Modifier and Type
Method
Description
`Comparator<? super K>`
`comparator()`
Returns the comparator used to order the keys in this map, or `null` if this map uses the natural ordering of its keys.
`Set<Map.Entry<K,V>>`
`entrySet()`
Returns a `Set` view of the mappings contained in this map.
`K`
`firstKey()`
Returns the first (lowest) key currently in this map.
`K`
`lastKey()`
Returns the last (highest) key currently in this map.
`default V`
`putFirst(K k, V v)`
Throws `UnsupportedOperationException`.
`default V`
`putLast(K k, V v)`
Throws `UnsupportedOperationException`.
`Collection<V>`
`values()`
Returns a `Collection` view of the values contained in this map.

## Method Details

### subMap

ConcurrentNavigableMap<K,V> subMap(K fromKey, boolean fromInclusive, K toKey, boolean toInclusive)
Description copied from interface: `NavigableMap`
Returns a view of the portion of this map whose keys range from `fromKey` to `toKey`. If `fromKey` and `toKey` are equal, the returned map is empty unless `fromInclusive` and `toInclusive` are both true. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

The returned map will throw an `IllegalArgumentException` on an attempt to insert a key outside of its range, or to construct a submap either of whose endpoints lie outside its range.

Specified by:
  `subMap` in interface `NavigableMap<K,V>`
Parameters:
  `fromKey` - low endpoint of the keys in the returned map
  `fromInclusive` - `true` if the low endpoint is to be included in the returned view
  `toKey` - high endpoint of the keys in the returned map
  `toInclusive` - `true` if the high endpoint is to be included in the returned view
Returns:
  a view of the portion of this map whose keys range from `fromKey` to `toKey`
Throws:
  `ClassCastException` - if `fromKey` and `toKey` cannot be compared to one another using this map's comparator (or, if the map has no comparator, using natural ordering). Implementations may, but are not required to, throw this exception if `fromKey` or `toKey` cannot be compared to keys currently in the map.
  `NullPointerException` - if `fromKey` or `toKey` is null and this map does not permit null keys
  `IllegalArgumentException` - if `fromKey` is greater than `toKey`; or if this map itself has a restricted range, and `fromKey` or `toKey` lies outside the bounds of the range

### headMap

ConcurrentNavigableMap<K,V> headMap(K toKey, boolean inclusive)
Description copied from interface: `NavigableMap`
Returns a view of the portion of this map whose keys are less than (or equal to, if `inclusive` is true) `toKey`. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

The returned map will throw an `IllegalArgumentException` on an attempt to insert a key outside its range.

Specified by:
  `headMap` in interface `NavigableMap<K,V>`
Parameters:
  `toKey` - high endpoint of the keys in the returned map
  `inclusive` - `true` if the high endpoint is to be included in the returned view
Returns:
  a view of the portion of this map whose keys are less than (or equal to, if `inclusive` is true) `toKey`
Throws:
  `ClassCastException` - if `toKey` is not compatible with this map's comparator (or, if the map has no comparator, if `toKey` does not implement `Comparable`). Implementations may, but are not required to, throw this exception if `toKey` cannot be compared to keys currently in the map.
  `NullPointerException` - if `toKey` is null and this map does not permit null keys
  `IllegalArgumentException` - if this map itself has a restricted range, and `toKey` lies outside the bounds of the range

### tailMap

ConcurrentNavigableMap<K,V> tailMap(K fromKey, boolean inclusive)
Description copied from interface: `NavigableMap`
Returns a view of the portion of this map whose keys are greater than (or equal to, if `inclusive` is true) `fromKey`. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

The returned map will throw an `IllegalArgumentException` on an attempt to insert a key outside its range.

Specified by:
  `tailMap` in interface `NavigableMap<K,V>`
Parameters:
  `fromKey` - low endpoint of the keys in the returned map
  `inclusive` - `true` if the low endpoint is to be included in the returned view
Returns:
  a view of the portion of this map whose keys are greater than (or equal to, if `inclusive` is true) `fromKey`
Throws:
  `ClassCastException` - if `fromKey` is not compatible with this map's comparator (or, if the map has no comparator, if `fromKey` does not implement `Comparable`). Implementations may, but are not required to, throw this exception if `fromKey` cannot be compared to keys currently in the map.
  `NullPointerException` - if `fromKey` is null and this map does not permit null keys
  `IllegalArgumentException` - if this map itself has a restricted range, and `fromKey` lies outside the bounds of the range

### subMap

ConcurrentNavigableMap<K,V> subMap(K fromKey, K toKey)
Description copied from interface: `NavigableMap`
Returns a view of the portion of this map whose keys range from `fromKey`, inclusive, to `toKey`, exclusive. (If `fromKey` and `toKey` are equal, the returned map is empty.) The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

The returned map will throw an `IllegalArgumentException` on an attempt to insert a key outside its range.

Equivalent to `subMap(fromKey, true, toKey, false)`.

Specified by:
  `subMap` in interface `NavigableMap<K,V>`
Specified by:
  `subMap` in interface `SortedMap<K,V>`
Parameters:
  `fromKey` - low endpoint (inclusive) of the keys in the returned map
  `toKey` - high endpoint (exclusive) of the keys in the returned map
Returns:
  a view of the portion of this map whose keys range from `fromKey`, inclusive, to `toKey`, exclusive
Throws:
  `ClassCastException` - if `fromKey` and `toKey` cannot be compared to one another using this map's comparator (or, if the map has no comparator, using natural ordering). Implementations may, but are not required to, throw this exception if `fromKey` or `toKey` cannot be compared to keys currently in the map.
  `NullPointerException` - if `fromKey` or `toKey` is null and this map does not permit null keys
  `IllegalArgumentException` - if `fromKey` is greater than `toKey`; or if this map itself has a restricted range, and `fromKey` or `toKey` lies outside the bounds of the range

### headMap

ConcurrentNavigableMap<K,V> headMap(K toKey)
Description copied from interface: `NavigableMap`
Returns a view of the portion of this map whose keys are strictly less than `toKey`. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

The returned map will throw an `IllegalArgumentException` on an attempt to insert a key outside its range.

Equivalent to `headMap(toKey, false)`.

Specified by:
  `headMap` in interface `NavigableMap<K,V>`
Specified by:
  `headMap` in interface `SortedMap<K,V>`
Parameters:
  `toKey` - high endpoint (exclusive) of the keys in the returned map
Returns:
  a view of the portion of this map whose keys are strictly less than `toKey`
Throws:
  `ClassCastException` - if `toKey` is not compatible with this map's comparator (or, if the map has no comparator, if `toKey` does not implement `Comparable`). Implementations may, but are not required to, throw this exception if `toKey` cannot be compared to keys currently in the map.
  `NullPointerException` - if `toKey` is null and this map does not permit null keys
  `IllegalArgumentException` - if this map itself has a restricted range, and `toKey` lies outside the bounds of the range

### tailMap

ConcurrentNavigableMap<K,V> tailMap(K fromKey)
Description copied from interface: `NavigableMap`
Returns a view of the portion of this map whose keys are greater than or equal to `fromKey`. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

The returned map will throw an `IllegalArgumentException` on an attempt to insert a key outside its range.

Equivalent to `tailMap(fromKey, true)`.

Specified by:
  `tailMap` in interface `NavigableMap<K,V>`
Specified by:
  `tailMap` in interface `SortedMap<K,V>`
Parameters:
  `fromKey` - low endpoint (inclusive) of the keys in the returned map
Returns:
  a view of the portion of this map whose keys are greater than or equal to `fromKey`
Throws:
  `ClassCastException` - if `fromKey` is not compatible with this map's comparator (or, if the map has no comparator, if `fromKey` does not implement `Comparable`). Implementations may, but are not required to, throw this exception if `fromKey` cannot be compared to keys currently in the map.
  `NullPointerException` - if `fromKey` is null and this map does not permit null keys
  `IllegalArgumentException` - if this map itself has a restricted range, and `fromKey` lies outside the bounds of the range

### descendingMap

ConcurrentNavigableMap<K,V> descendingMap()
Returns a reverse order view of the mappings contained in this map. The descending map is backed by this map, so changes to the map are reflected in the descending map, and vice-versa.

The returned map has an ordering equivalent to `Collections.reverseOrder``(comparator())`. The expression `m.descendingMap().descendingMap()` returns a view of `m` essentially equivalent to `m`.

Specified by:
  `descendingMap` in interface `NavigableMap<K,V>`
Returns:
  a reverse order view of this map

### navigableKeySet

NavigableSet<K> navigableKeySet()
Returns a `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in ascending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

The view's iterators and spliterators are weakly consistent.

Specified by:
  `navigableKeySet` in interface `NavigableMap<K,V>`
Returns:
  a navigable set view of the keys in this map

### keySet

NavigableSet<K> keySet()
Returns a `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in ascending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

The view's iterators and spliterators are weakly consistent.

This method is equivalent to method `navigableKeySet`.

Specified by:
  `keySet` in interface `Map<K,V>`
Specified by:
  `keySet` in interface `SortedMap<K,V>`
Returns:
  a navigable set view of the keys in this map

### descendingKeySet

NavigableSet<K> descendingKeySet()
Returns a reverse order `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in descending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

The view's iterators and spliterators are weakly consistent.

Specified by:
  `descendingKeySet` in interface `NavigableMap<K,V>`
Returns:
  a reverse order navigable set view of the keys in this map